import { system, world } from '@minecraft/server';
import { gunLoop } from './guns/main';
import { bulletEntityImpact } from './guns/bullet';
import 'components/lights';
import 'components/props';

const init = () => {
  autoRunTick();
  events();
};

const tick = () => {
  gunLoop();
};

const autoRunTick = () => {
  tick();
  const timeoutId = system.runTimeout(() => {
    try {
      system.clearRun(timeoutId);
      autoRunTick();
    } catch (error) {
      console.warn(error);
    }
  }, 2);
};

const events = () => {
  world.afterEvents.projectileHitEntity.subscribe(bulletEntityImpact);
  world.afterEvents.entityDie.subscribe((data) => {
    const entitya = data.deadEntity;
    const playera = data.damageSource;
    if (entitya.typeId == "minecraft:zombie") {
        playera.damagingEntity.runCommandAsync(`scoreboard players add @s points 1`)
        playera.damagingEntity.runCommandAsync(`playsound gun.gun @s`)
        playera.damagingEntity.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§l§e1 Point"}]}`)
    };
    if (entitya.typeId == "minecraft:iron_golem") {
        playera.damagingEntity.runCommandAsync(`scoreboard players add @s points 4`)
        playera.damagingEntity.runCommandAsync(`playsound gun.gun @s`)
        playera.damagingEntity.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§l§e4 Points"}]}`)
    };
  });
};

init();
